<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

//type
import type { UtilityCost } from '@/types/utiliycost/UtilityCost'
import type { UtilityDetail } from '@/types/utiliycost/UtilityDetail'

// store
import { useUtilityStore } from '../../stores/utilitycost/utilitycost'
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

//view
import UtilityNewBill from './UtilityNewBill.vue'
import { useUserStore } from '@/stores/user'

const utilityStore = useUtilityStore()
const userStore = useUserStore()
const UCDialog = ref(false)
const divItems = ref<HTMLElement | null>(null)
const sortOrder = ref<'asc' | 'desc'>('asc')
let itemIndex = ref(-1)
const detailOfBill = ref(true)

function searchIndex(item: UtilityCost) {
  if ('id' in item) {
    itemIndex.value = utilityStore.utilityBills.findIndex((bill) => bill.id === item.id)
    console.log('itemIndex:', itemIndex.value)
    console.log('bill items select', utilityStore.utilityBills[itemIndex.value])
    console.log('bill items select', utilityStore.utilityBills[itemIndex.value]?.ucDetails)

    //openDetail Stock Dialog
    detailOfBill.value = true
  }
}

onMounted(() => {
  utilityStore.initUtilityCost.user = userStore.currentUser
  console.log('utilityStore.utilityBills:', utilityStore.initUtilityCost.user)
  utilityStore.getUtilityBills()
})

function onSubmit() {
  useUtilityStore
}

function formatDate(dateString: any) {
  const date = new Date(dateString)
  return date.toLocaleDateString('th-TH', {
    day: '2-digit',
    month: 'long',
    year: 'numeric'
  })
}
function toggleSortOrderBill(columnKey: keyof UtilityCost) {
  const sortOrderMultiplier = sortOrder.value === 'asc' ? 1 : -1

  utilityStore.utilityBills.sort((a: UtilityCost, b: UtilityCost) => {
    const aValue = a[columnKey]?.toString() ?? ''
    const bValue = b[columnKey]?.toString() ?? ''

    return aValue > bValue ? sortOrderMultiplier : aValue < bValue ? -sortOrderMultiplier : 0
  })

  sortOrder.value = sortOrder.value === 'asc' ? 'desc' : 'asc'
}
function toggleSortOrderItemBill(columnKey: keyof UtilityDetail) {
  const sortOrderMultiplier = sortOrder.value === 'asc' ? 1 : -1

  if (
    itemIndex.value !== undefined &&
    utilityStore.utilityBills[itemIndex.value] &&
    utilityStore.utilityBills[itemIndex.value]!.ucDetails
  ) {
    const currentIndex = itemIndex.value

    // Sort only if items is not undefined
    utilityStore.utilityBills[currentIndex]!.ucDetails!.sort(
      (a: UtilityDetail, b: UtilityDetail) => {
        const aValue = a[columnKey] ?? ''
        const bValue = b[columnKey] ?? ''

        if (typeof aValue === 'number' && typeof bValue === 'number') {
          // If values are numbers, directly compare them
          return aValue > bValue ? sortOrderMultiplier : aValue < bValue ? -sortOrderMultiplier : 0
        } else {
          // If values are not numbers, convert to strings and compare
          return aValue.toString() > bValue.toString()
            ? sortOrderMultiplier
            : aValue.toString() < bValue.toString()
              ? -sortOrderMultiplier
              : 0
        }
      }
    )
  }

  sortOrder.value = sortOrder.value === 'asc' ? 'desc' : 'asc'
}
</script>

<template>
  <div>
    <v-container>
      <v-laout>
        <v-card border>
          <v-card-title class="text-h5 bg-blue" height="60"> Utility Cost </v-card-title>
          <v-divider class="border-opacity-50" color="blue" style="padding: 10px"></v-divider>

          <v-row class="d-flex justify-center">
            <v-col cols="12" sm="12" md="4">
              <v-card variant="outlined" color="primary">
                <v-card-title>
                  <v-row>
                    <v-col cols="6"> Bill of Ulity Cost </v-col>
                    <v-col cols="6" class="d-flex justify-end">
                      <v-btn @click="utilityStore.newUcDialog = true" size="small">
                        New Invoice
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-card-title>

                <v-table fixed-header style="height: 400px; overflow-y: auto">
                  <thead>
                    <tr>
                      <th class="text-left" @click="() => toggleSortOrderBill('id')">ID</th>
                      <th class="text-left">ชื่อพนักงาน</th>
                      <th class="text-left" @click="() => toggleSortOrderBill('creatDate')">
                        วันที่
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr
                      v-for="(item, index) in utilityStore.utilityBills"
                      :key="index"
                      @click="() => searchIndex(item)"
                    >
                      <td>{{ item.id }}</td>
                      <td>{{ item.user.name }}</td>
                      <td>{{ formatDate(item.creatDate) }}</td>
                    </tr>
                  </tbody>
                </v-table>
              </v-card>
            </v-col>
            <v-col cols="12" sm="12" md="6">
              <v-card>
                <v-card v-if="detailOfBill == true" variant="outlined" color="primary" height="100">
                  <v-card-title>รายละเอียดการบันทึก</v-card-title>
                  <v-row>
                    <v-cols cols="41" style="padding-left: 30px; padding-top: 10px">
                      <v-avatar rounded="0">
                        <v-img
                          :src="
                            'http://localhost:3000/images/users/' +
                            utilityStore.utilityBills[itemIndex]?.user.image
                          "
                        ></v-img>
                      </v-avatar>
                    </v-cols>
                    <v-col cols="10">
                      <v-card-subtitle>
                        ชื่อพนักงาน :
                        {{ utilityStore.utilityBills[itemIndex]?.user.name || 'Unknown User' }}
                        วันที่ :
                        {{ formatDate(utilityStore.utilityBills[itemIndex]?.creatDate) }}
                      </v-card-subtitle>
                      <v-card-subtitle>
                        จำนวนรายการ :
                        {{ utilityStore.utilityBills[itemIndex]?.totalItem }}
                        รายการ รวมเป็นเงิน :
                        {{ utilityStore.utilityBills[itemIndex]?.totalPrice }}
                        บาท
                      </v-card-subtitle>
                    </v-col>
                    <v-col cols="12">
                      <v-card-subtitle>
                        รวมเป็นเงิน :
                        {{ utilityStore.utilityBills[itemIndex]?.totalPrice }}
                      </v-card-subtitle>
                    </v-col>
                  </v-row>
                </v-card>
                <v-card title="ค่าใช้จ่าย" variant="outlined" color="primary">
                  <v-table fixed-header style="height: 295px; overflow-y: auto; max-width: 675px">
                    <thead>
                      <tr>
                        <th class="text-left" @click="() => toggleSortOrderItemBill('id')">ID</th>
                        <th class="text-left" @click="() => toggleSortOrderItemBill('type')">
                          ประเภทค่าใช้จ่าย
                        </th>
                        <th class="text-left" @click="() => toggleSortOrderItemBill('date')">
                          วันที่
                        </th>
                        <th class="text-left" @click="() => toggleSortOrderItemBill('price')">
                          ค่าใช้จ่าย
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <template v-if="utilityStore.utilityBills[itemIndex]">
                        <tr
                          v-for="(item, index) in utilityStore.utilityBills[itemIndex]?.ucDetails"
                          :key="index"
                        >
                          <td>{{ item.id }}</td>
                          <td>{{ item.type }}</td>
                          <td>{{ formatDate(item.date) }}</td>
                          <td>{{ item.price }}</td>
                        </tr>
                      </template>
                    </tbody>
                  </v-table>
                </v-card>
              </v-card>
            </v-col>
          </v-row>
        </v-card>
      </v-laout>
    </v-container>
  </div>

  <!-- newInv -->
  <UtilityNewBill v-model="utilityStore.newUcDialog"></UtilityNewBill>
</template>
